SystemOrganization addCategory: #'P4-ASM'!
SystemOrganization addCategory: #'P4-ASM-Values'!

P4Object subclass: #P4ASMValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM-Values'!

P4ASMValue subclass: #P4ASMConstant
	instanceVariableNames: 'constantValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM-Values'!

!P4ASMConstant methodsFor: 'accessing' stamp: 'ToonVerwaest 5/5/2011 18:35'!
constantValue
	^ constantValue! !

!P4ASMConstant methodsFor: 'accessing' stamp: 'ToonVerwaest 5/5/2011 18:35'!
constantValue: anObject
	constantValue := anObject! !

!P4ASMConstant methodsFor: 'testing' stamp: 'ToonVerwaest 5/12/2011 22:43'!
isAccess
	^ false! !

!P4ASMConstant methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/22/2011 16:17'!
isConstant 
	^ true! !

P4ASMConstant subclass: #P4ASMExternalReference
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM-Values'!

!P4ASMExternalReference methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/22/2011 17:16'!
constantValue 
	^0! !

!P4ASMExternalReference methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/23/2011 17:14'!
isExternal 
	^ true! !

!P4ASMExternalReference methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/22/2011 17:16'!
label
	^ label! !

!P4ASMExternalReference methodsFor: 'as yet unclassified' stamp: 'OliFlueckiger 6/22/2011 17:16'!
label: aLabel
	label := aLabel ! !

P4ASMValue subclass: #P4ASMReference
	instanceVariableNames: 'target label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM-Values'!

P4ASMReference subclass: #P4ASMObjectAccess
	instanceVariableNames: 'offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM-Values'!

!P4ASMObjectAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 6/17/2011 15:00'!
offset
	^ offset ifNil: [ 0 ]! !

!P4ASMObjectAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 6/15/2011 16:58'!
offset: anObject
	offset := anObject! !

!P4ASMReference methodsFor: 'testing' stamp: 'ToonVerwaest 6/17/2011 15:00'!
isAccess
	^ true! !

!P4ASMReference methodsFor: 'testing' stamp: 'OliFlueckiger 6/22/2011 16:18'!
isRelative 
	^ true! !

!P4ASMReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/7/2011 15:52'!
label
	^ label! !

!P4ASMReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/22/2011 16:34'!
label: anObject
	label := anObject! !

!P4ASMReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/22/2011 16:20'!
offset
	^0! !

!P4ASMReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/22/2011 15:54'!
target
	^ target! !

!P4ASMReference methodsFor: 'accessing' stamp: 'OliFlueckiger 6/22/2011 16:33'!
target: anObject
	target := anObject! !

P4ASMValue subclass: #P4ASMRegister
	instanceVariableNames: 'name index combination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM-Values'!

!P4ASMRegister class methodsFor: 'instance creation' stamp: 'ToonVerwaest 5/4/2011 20:48'!
named: aName
	^ self new name: aName! !

!P4ASMRegister methodsFor: 'converting' stamp: 'ToonVerwaest 5/5/2011 14:00'!
accessAt: offset
	^ P4ASMRegisterAccess new
		register: self;
		offset: offset! !

!P4ASMRegister methodsFor: 'converting' stamp: 'CamilloBruni 4/3/2012 15:29'!
asP4ASMRegister
	^ self! !

!P4ASMRegister methodsFor: 'converting' stamp: 'ToonVerwaest 5/7/2011 14:04'!
asRegister! !

!P4ASMRegister methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
combination
	^ combination! !

!P4ASMRegister methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
combination: anObject
	combination := anObject! !

!P4ASMRegister methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
index
	^ index! !

!P4ASMRegister methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
index: anObject
	index := anObject! !

!P4ASMRegister methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
name
	^ name! !

!P4ASMRegister methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
name: anObject
	name := anObject! !

!P4ASMRegister methodsFor: 'instruction-creation' stamp: 'OliFlueckiger 5/26/2011 14:10'!
pop
	^ P4TACPop new register: self! !

!P4ASMRegister methodsFor: 'printing' stamp: 'OliFlueckiger 5/6/2011 18:05'!
printOn: stream
	stream << '%' << name! !

!P4ASMRegister methodsFor: 'printing' stamp: 'OliFlueckiger 5/4/2011 23:20'!
printString 
	^ '%',name! !

!P4ASMRegister methodsFor: 'instruction-creation' stamp: 'OliFlueckiger 5/26/2011 14:10'!
push
	^ P4TACPush new register: self! !

P4ASMValue subclass: #P4ASMRegisterAccess
	instanceVariableNames: 'register offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM-Values'!

!P4ASMRegisterAccess methodsFor: 'converting' stamp: 'ToonVerwaest 5/7/2011 14:04'!
asRegister
	^ register! !

!P4ASMRegisterAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/5/2011 18:36'!
combination
	^ register combination! !

!P4ASMRegisterAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/6/2011 17:18'!
index
	^ register index! !

!P4ASMRegisterAccess methodsFor: 'testing' stamp: 'ToonVerwaest 5/4/2011 20:51'!
isAccess
	^ true! !

!P4ASMRegisterAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/12/2011 22:42'!
isDirect
	^ false! !

!P4ASMRegisterAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
offset
	^ offset! !

!P4ASMRegisterAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
offset: anObject
	offset := anObject! !

!P4ASMRegisterAccess methodsFor: 'accessing' stamp: 'OliFlueckiger 5/13/2011 15:06'!
printOn: stream
	register printOn: stream .
	stream << '[' << offset asString << ']'  ! !

!P4ASMRegisterAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
register
	^ register! !

!P4ASMRegisterAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
register: anObject
	register := anObject! !

P4ASMRegisterAccess subclass: #P4ASMRegisterDynAccess
	instanceVariableNames: 'offsetRegister'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM-Values'!

!P4ASMRegisterDynAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
offsetRegister
	^ offsetRegister! !

!P4ASMRegisterDynAccess methodsFor: 'accessing' stamp: 'ToonVerwaest 5/4/2011 20:47'!
offsetRegister: anObject
	offsetRegister := anObject! !

!P4ASMValue methodsFor: 'accessing' stamp: 'ToonVerwaest 5/5/2011 18:36'!
combination
	^ 0! !

!P4ASMValue methodsFor: 'testing' stamp: 'ToonVerwaest 5/4/2011 20:51'!
isAccess
	^ false! !

!P4ASMValue methodsFor: 'testing' stamp: 'ToonVerwaest 5/5/2011 16:47'!
isConstant
	^ false! !

!P4ASMValue methodsFor: 'testing' stamp: 'OliFlueckiger 6/23/2011 17:14'!
isExternal
	^false! !

!P4ASMValue methodsFor: 'testing' stamp: 'OliFlueckiger 6/22/2011 16:17'!
isRelative
	^ false! !

P4Object subclass: #P4TAC2ASM
	instanceVariableNames: 'currentCallable methods asm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'P4-ASM'!

!P4TAC2ASM methodsFor: 'accessing' stamp: 'CamilloBruni 3/29/2012 13:41'!
asm: anAssembler
	asm := anAssembler! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 4/13/2012 16:12'!
checkShortJump: aJump for: aBlock
	| result |
	"aJump isShort ifTrue: [ asm forceShortJump ]."
	self halt: 'check long-/short-jump handling in asmjit'.
	result := aBlock value.
	"asm unforceShortJump."
	^ result! !

!P4TAC2ASM methodsFor: 'compiling' stamp: 'CamilloBruni 4/19/2012 14:07'!
compile: aMethod
	asm reset.
	
	asm label: aMethod name.
	"create temporary label for the main code block of the method"
	asm labelNamed: (self labelForBlock: aMethod invokeBlock).
	
	self compileCallable: aMethod.
	
	aMethod stream: asm stream.
	aMethod closures do: [ :aClosure |
		asm tagClosure: aClosure.
		self compileCallable: aClosure ].
	
	asm finalize.
	
	^ P4Method fromTac: aMethod.	
	! !

!P4TAC2ASM methodsFor: 'compiling' stamp: 'CamilloBruni 4/19/2012 13:55'!
compileBasicBlock: aCodeBlock
	self labelBlock: aCodeBlock.
	aCodeBlock do: [ :anInstruction | anInstruction accept: self ]! !

!P4TAC2ASM methodsFor: 'compiling' stamp: 'CamilloBruni 12/15/2011 14:14'!
compileCallable: aCallable
	| currentBasicBlock |
	
	methods add: aCallable.
	aCallable setupFrame: self.
	currentBasicBlock := aCallable entry.
	[ currentBasicBlock atEnd ] whileFalse: [
		self compileBasicBlock: currentBasicBlock.
		currentBasicBlock := currentBasicBlock nextBlock ].
	aCallable invokeBlock ifNotNil: [self compileBasicBlock: aCallable invokeBlock].
	currentCallable := nil.! !

!P4TAC2ASM methodsFor: 'compiling' stamp: 'OliFlueckiger 6/16/2011 14:07'!
initialize 
	methods := OrderedCollection new.! !

!P4TAC2ASM methodsFor: 'compiling' stamp: 'CamilloBruni 4/19/2012 14:01'!
labelBlock: aCodeBlock 
	asm label: (self labelForBlock: aCodeBlock).! !

!P4TAC2ASM methodsFor: 'compiling' stamp: 'CamilloBruni 4/19/2012 14:01'!
labelForBlock: aCodeBlock
	^ currentCallable name, ' ', aCodeBlock name! !

!P4TAC2ASM methodsFor: 'private' stamp: 'CamilloBruni 4/19/2012 14:12'!
setupStaticFrame: aCallable
	| entry currentBasicBlock |
	currentCallable 
		ifNotNil: [ ^ self error: 'Should not build up a frame while another frame is active' ].
	currentCallable := aCallable.
	
	currentBasicBlock := currentCallable preamble.	
	[ currentBasicBlock == currentCallable argumentLoading  ] whileFalse: [
		self compileBasicBlock: currentBasicBlock.
		currentBasicBlock := currentBasicBlock nextBlock ].	

	currentCallable frameSize > 0
		ifTrue: [ 
			asm
				sub: (currentCallable frameSize * asm pointerSize)
				from: asm stackPointer ].

	currentBasicBlock := currentCallable argumentLoading .	
	[ currentBasicBlock == currentCallable entry ] whileFalse: [
		self compileBasicBlock: currentBasicBlock.
		currentBasicBlock := currentBasicBlock nextBlock ].
! !

!P4TAC2ASM methodsFor: 'private' stamp: 'CamilloBruni 4/19/2012 14:12'!
tearDownFrame: shouldKeepArguments
	currentCallable frameSize > 0
		ifTrue: [ 
			asm
				add: (currentCallable frameSize * asm pointerSize)
				to: asm stackPointer ].
	
	self compileBasicBlock: currentCallable postamble. 
	shouldKeepArguments 
		ifFalse: [ self compileBasicBlock: currentCallable popArguments ]
! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitAdd: anInstruction
	^ asm
		add: (anInstruction left accept: self)
		to: (anInstruction right accept: self)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitAnd: anInstruction
	^ asm
		and: (anInstruction left accept: self)
		with: (anInstruction right accept: self)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitAssignment: anAssignment
	^ asm
		mov: (anAssignment origin accept: self)
		to: (anAssignment target accept: self)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitBitShift: anInstruction
	^ asm
		shl: (anInstruction target accept: self)
		by: (anInstruction bits)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitBitShiftRight: anInstruction
	^ asm
		shr: (anInstruction target accept: self)
		by: (anInstruction bits)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 4/4/2012 19:35'!
visitBitTest: anInstruction
	^ asm 
		bt: (anInstruction location accept: self) 
		at: (anInstruction bit)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 4/4/2012 19:53'!
visitCall: aNative
	self flag: 'properly install the method reference'.
	^ asm call: aNative offset    ! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitCompare: aComparison
	^ asm
		cmp: (aComparison left accept: self)
		with: (aComparison right accept: self)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 4/19/2012 14:10'!
visitConditionalJump: aJump
	
	| label |
	label := self labelForBlock: aJump target.
	
	aJump isEqualsTest ifTrue: [ 
		aJump isCarryTest ifTrue: [ 
			^ self error: 'combined checks of multiple flags (jge an the like) is not yet supported' ].
		^ aJump isEqualsSet
			ifTrue: [ asm je: label ]
			ifFalse: [ asm jne: label ]]. 
		
	aJump ifCarryTest: [ 
		aJump ifCarrySet: [ ^ asm jc: label ].
		^ asm jnc: label ].

	self error: 'this is not a conditional jump: ', aJump asString.! !

!P4TAC2ASM methodsFor: 'values' stamp: 'CamilloBruni 4/4/2012 19:51'!
visitConstant: aConstant
	^ aConstant constantValue! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitConstantReference: aReference
	^ asm externalReference: aReference target! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitHalt: aHalt
	^ asm int3! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitIndirectCall: aCall
	^ asm indirectCall: ( aCall register accept: self )! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitIndirectJump: aJump
	^ asm indirectJmp: ( aJump register accept: self )! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 4/13/2012 16:11'!
visitJump: aJump
	^ asm jmp: aJump target! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitLoadAddress: aLoadAddress
	^ asm
		lea: (aLoadAddress origin accept: self)
		to: (aLoadAddress target accept: self)! !

!P4TAC2ASM methodsFor: 'values' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitMethodObjectAccess: aLiteral
	^ (P4ASMObjectAccess new)
		target: aLiteral target;
		offset: aLiteral index * asm pointerSize  ! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitOr: anInstruction
	^ asm
		or: (anInstruction left accept: self)
		with: (anInstruction right accept: self)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitPop: aPop
	^ asm pop: aPop register! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitPush: aPush
	^ asm push: aPush register! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitReference: aReference
	^ asm reference: aReference target.! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 4/19/2012 14:50'!
visitReturn: aReturn
	aReturn tearDown ifTrue: [ self tearDownFrame: false ].
	asm ret.! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitSub: anInstruction
	^ asm
		sub: (anInstruction left accept: self)
		from: (anInstruction right accept: self)! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'OliFlueckiger 9/7/2011 14:42'!
visitTeardown: aReturn
	self tearDownFrame: aReturn shouldKeepArguments.! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitTest: anInstruction
	^ asm
		test: (anInstruction left accept: self)
		with: (anInstruction right accept: self)! !

!P4TAC2ASM methodsFor: 'values' stamp: 'OliFlueckiger 5/31/2011 18:15'!
visitVariable: aVariable
	^ aVariable asAsm! !

!P4TAC2ASM methodsFor: 'values' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitVariableAccess: aVariableAccess
	^ aVariableAccess register accessAt: aVariableAccess index * asm pointerSize! !

!P4TAC2ASM methodsFor: 'visiting' stamp: 'OliFlueckiger 6/10/2011 14:27'!
visitVolatileFence: aP4TACVolatileFence ! !

!P4TAC2ASM methodsFor: 'instructions' stamp: 'CamilloBruni 3/29/2012 13:41'!
visitXor: anInstruction
	^ asm
		xor: (anInstruction left accept: self)
		with: (anInstruction right accept: self)! !
